Loading...
Searching...
No Matches
BALL::VIEW::GeometricObject Class Reference
Visualisation » Kernel » Geometric primitives and their management

`#include <BALL/VIEW/KERNEL/geometricObject.h>`

Inheritance diagram for BALL::VIEW::GeometricObject:

## Public Member Functions

cloning facility.
| GeometricObject ()
| GeometricObject (const GeometricObject &object)
virtual | ~GeometricObject ()
virtual void | clear ()
Assignment methods
void | set (const GeometricObject &object)
GeometricObject & | operator= (const GeometricObject &object)
void | swap (GeometricObject &object)
Accessors: inspectors and mutators
void | setComposite (const Composite *composite)
const Composite * | getComposite () const

## debuggers and diagnostics

virtual bool | isValid () const
virtual void | dump (std::ostream &s=std::cout, Size depth=0) const
void | setColor (const ColorRGBA &color)
void | setColor (const ColorUnit &red, const ColorUnit &green, const ColorUnit &blue, const ColorUnit &alpha=(float) 1)
const ColorRGBA & | getColor () const
ColorRGBA & | getColor ()
void | getColor (ColorUnit &red, ColorUnit &green, ColorUnit &blue, ColorUnit &alpha) const
void | getColors (HashSet< String > &colors)
| Insert the colors of this object into the hashset.
bool | operator== (const GeometricObject &object) const
| Needed for MSVC.
bool | operator< (const GeometricObject &object) const
| Needed for MSVC.
virtual void | getVertices (std::vector< Vector3 > &) const

## Detailed Description

GeometricObject class. The class GeometricObject is the most important base class for a geometric primitive. All geometric primitives must be derived from this class.
This class contains only the general information like color, name and the composite pointer.

Definition at line 36 of file geometricObject.h.

## Constructor & Destructor Documentation

## GeometricObject() [1/2]

BALL::VIEW::GeometricObject::GeometricObject | ( |  | ) |

Default Constructor. The state of this geometricObject is:

- selected color is set to yellow (1.0, 1.0, 0.0, 1.0)
- name is set to "unknown"
- typename is set to "GeometricObject"
  Returns
    GeometricObject new constructed geometricObject
  See also
    ColorRGBA

## GeometricObject() [2/2]

BALL::VIEW::GeometricObject::GeometricObject | ( | const GeometricObject & | object | ) |

Copy constructor.

Parameters

  object | the geometricObject to be copied (cloned)

## ~GeometricObject()

virtual BALL::VIEW::GeometricObject::~GeometricObject | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## clear()

virtual void BALL::VIEW::GeometricObject::clear | ( |  | ) |

virtual

Explicit default initialization. Set the state of this geometricObject to the default values. The state of this geometricObject is:

- selected color is set to yellow (1.0, 1.0, 0.0, 1.0)
- name is set to "unknown"

Reimplemented in BALL::VIEW::Box, BALL::VIEW::Disc, BALL::VIEW::Label, BALL::VIEW::Line, BALL::VIEW::Mesh, BALL::VIEW::MultiLine, BALL::VIEW::Point, BALL::VIEW::SimpleBox, BALL::VIEW::Sphere, BALL::VIEW::Tube, BALL::VIEW::TwoColoredLine, and BALL::VIEW::TwoColoredTube.

## dump()

virtual void BALL::VIEW::GeometricObject::dump | ( | std::ostream & | s = std::cout,
|  | Size | depth = 0 ) const

virtual

Internal value dump. Dump the current state of this geometricObject to the output ostream s with dumping depth depth.

Parameters

  s | output stream where to output the state of this geometricObject
  depth | the dumping depth

See also
  ColorRGBA::dump

Reimplemented in BALL::VIEW::Box, BALL::VIEW::Disc, BALL::VIEW::Label, BALL::VIEW::Line, BALL::VIEW::Mesh, BALL::VIEW::MultiLine, BALL::VIEW::Point, BALL::VIEW::SimpleBox, BALL::VIEW::Sphere, BALL::VIEW::Tube, BALL::VIEW::TwoColoredLine, and BALL::VIEW::TwoColoredTube.

## getColor() [1/3]

ColorRGBA & BALL::VIEW::GeometricObject::getColor | ( |  | ) |

inline

Definition at line 147 of file geometricObject.h.

## getColor() [2/3]

const ColorRGBA & BALL::VIEW::GeometricObject::getColor | ( |  | ) | const

inline

Definition at line 143 of file geometricObject.h.

## getColor() [3/3]

void BALL::VIEW::GeometricObject::getColor | ( | ColorUnit & | red,
|  | ColorUnit & | green,
|  | ColorUnit & | blue,
|  | ColorUnit & | alpha ) const

inline

Definition at line 152 of file geometricObject.h.

## getColors()

void BALL::VIEW::GeometricObject::getColors | ( | HashSet< String > & | colors | ) |

Insert the colors of this object into the hashset.

## getComposite()

const Composite * BALL::VIEW::GeometricObject::getComposite | ( |  | ) | const

inline

Definition at line 104 of file geometricObject.h.

## getVertices()

virtual void BALL::VIEW::GeometricObject::getVertices | ( | std::vector< Vector3 > & |  | ) | const

inline virtual

Definition at line 169 of file geometricObject.h.

## isValid()

virtual bool BALL::VIEW::GeometricObject::isValid | ( |  | ) | const

inline virtual

Internal state and consistency self-validation. Initiate self-validation of the internal state and data structure consistencies of this geometricObject. If the internal state of this geometricObject is correct (self-validated) and consistent true is returned, false otherwise.

Returns
  bool true if the internal state of this geometricObject is correct

Reimplemented in BALL::VIEW::Box, BALL::VIEW::Disc, BALL::VIEW::Label, BALL::VIEW::Line, BALL::VIEW::Mesh, BALL::VIEW::MultiLine, BALL::VIEW::Point, BALL::VIEW::SimpleBox, BALL::VIEW::Sphere, BALL::VIEW::Tube, BALL::VIEW::TwoColoredLine, and BALL::VIEW::TwoColoredTube.

Definition at line 118 of file geometricObject.h.

## operator<()

bool BALL::VIEW::GeometricObject::operator< | ( | const GeometricObject & | object | ) | const

inline

Needed for MSVC.

Definition at line 165 of file geometricObject.h.

## operator=()

GeometricObject & BALL::VIEW::GeometricObject::operator= | ( | const GeometricObject & | object | ) |

Assignment operator. Calls set.

## operator==()

bool BALL::VIEW::GeometricObject::operator== | ( | const GeometricObject & | object | ) | const

inline

Needed for MSVC.

Definition at line 160 of file geometricObject.h.

## set()

void BALL::VIEW::GeometricObject::set | ( | const GeometricObject & | object | ) |

Assignment

## setColor() [1/2]

void BALL::VIEW::GeometricObject::setColor | ( | const ColorRGBA & | color | ) |

inline

Definition at line 132 of file geometricObject.h.

## setColor() [2/2]

void BALL::VIEW::GeometricObject::setColor | ( | const ColorUnit & | red,
|  | const ColorUnit & | green,
|  | const ColorUnit & | blue,
|  | const ColorUnit & | alpha = (float)1 )

inline

Definition at line 137 of file geometricObject.h.

## setComposite()

void BALL::VIEW::GeometricObject::setComposite | ( | const Composite * | composite | ) |

inline

Definition at line 100 of file geometricObject.h.

## swap()

void BALL::VIEW::GeometricObject::swap | ( | GeometricObject & | object | ) |

Swapping of geometricObjects.

Parameters

  object | the geometricObject being swapped with this geometricObject